-----BEGIN PGP SIGNED MESSAGE-----


- ------------------------------------------------------------------------------
                             ONLINE BOXES
- ------------------------------------------------------------------------------


{:speed}
{setv phase,GFX}
{call ccar}                check for carrier
{comp graphics,0}
{ifco rit}
{call bakdrop}
{call ccar}                check for carrier
{:nf6}
{setv usrprompt,Press [Enter] to continue}
{setv showfile,%adfile}    set file to show as ad
{call ET}                  Display showfile (ad)
{call ccar}                check for carrier
{call showtime}            display system time/pending event info
{call ccar}                check for carrier
{send ^[[24;1H^[[0;47;30m^[[K Please wait ...}
{call badbaud}             call BADBAUD to correct possible event overlap
{comp overlap}
{ifco ,quit}
{return}

 check for carrier-drop
  {:ccar}
  {comp ignorcar,y}
  {ifco rit}
  {ifca rit}                         if carrier present, return
  {pause 1}                          else, pause for one second
  {ifca rit}                         if carrier present, return
  {setv logtxt,Carrier Dropped} note in log
  {call getime}
  {goto begin}

 {:badbaud}
 {setv overlap}                  clear overlap flag
 {comp file,NONE}                if file = NONE
 {ifco rit}                      return
 {comp %file%}                    if file=nul
 {ifco rit}                      return
 {ifex %file%,,rit}              if file not exist, return
 {setv TIME1,%TIM}               TIME1: put time-left in temp var
 {setv ftcps,%DCE}               get CONNECT XXXX BPS rate
 {divi ftcps,10}                 FTCPS: File Transfer Characters Per Second
 {setv ftcpm,%ftcps}             convert FTCPS to --
 {mult ftcpm,60}                 FTCPM: File Transfer Characters Per Minute
 {file %file%}                   look at size of FXT102.EXE
 {setv fs,%_ffs}                 get file size in bytes
 {setv fts,%fs}                  put in FTS: File Transfer Seconds
 {divi fts,%ftcps}               divide FTS by current FTCPS
 {setv ftm,%fts}                 to get download time in seconds
 {divi ftm,60}                   convert to FTM: File Transfer Minutes
 {setv ftmrem,%_rem}             FTMREM: FTM remainder (leftover seconds)
 {comp ftmrem,0}                 are they zero?
 {ifco-gc getenths}              if greater, get extra tenths-of-seconds
 {setv FTMS,%ftm%.%tenths%}      FTMS: File Transfer Minutes and Seconds
 {setv total,%ftm}               put FTM in TOTAL
 {incr total,%cycbuf}            add Xm to to cover for carier drop
 {comp total,%tim}               compare total with time
 {ifco-G ,rit}                   if total time is greater than time-til-event
 {setv overlap,%total}           put total into OVERLAP
 {decr overlap,%tim}             subtract til-event time to get real overlap
 {call smeg}
 {return}


        {:smeg}
        {setv usrprompt,Press [Enter] to continue}
        {setv txt1,=========== A system event is pending ============}
        {setv txt2, }
        {setv txt3,  %Downfile% transfer rate: %FTCPM% bytes per min.}
        {setv txt4,  File download time: %FTMS% minutes}
        {setv txt5,  File error buffer: %FILERR% minutes}
        {setv txt6,  Next system event in: %TIM% minutes}
        {setv txt7,  Potential time overlap: %OVERLAP% minutes}
        {setv txt8, }
        {setv txt9,===========  Please try again later!  ============}
        {setv txt10}
        {call explode}
        {setg 15}
        {gets-h ap,1}       wait for user to finish reading (user input timeout)
        {setv overlap,yes}
        {setv logtxt,Potential event overlap}
        {call getime}
        {return}


{:getenths}
{setv tenths,60}        set TENTHS to 60 seconds, then find out how
{divi tenths,%ftmrem}   many times FTMREM seconds fit into it
{return}

{:quit}
{goto begin}


- ----AD----------

{:et}            display Edmonds Telegraph Ad
{call fil1}      read file
{call explode}   display via exploding window
{call clfil}     clear out vars
{setg 20}
{gets-h ap,1}       wait for user to finish reading (user input timeout)
{return}

 {:fil1}                    prepare to read file
 {rclos}
 {setv lnum,0}              clear NUM (line counter)
 {ifex %showfile%,,ret}     if file not there, escape ET altogther
 {ropen %showfile,ret}      open file
 {setv repeat,filo,24}
 {call repeat}
 {rclos}
 {return}

  {:filo}                    read lines from file
  {incr lnum}                increment counter
  {read %txtin}               read line
  {comp %txtin}               blank line?
  {ifco-c expblank}          if so, expand blank
  {setv-s txt%lnum,txtin}   assign to var
  {return}                   repeat until EOF

 {:expblank}                 expand blank lines
 {setv txtin, }
 {return}

 {:clfil}                    clear showfile vars
 {setv repeat,clfvars,%lnum%}
 {call repeat}
 {return}

 {:clfvars}
 {setv-s txt%timecount}
 {return}


- ------------------------------------------------------------------------------
    EXPLODE: Online box drawing routines
- ------------------------------------------------------------------------------

{:explode}       Exploding box
{comp graphics,0}
{ifco explotty}
{send ^[[24;1H^[[0;47;30m^[[K Transmitting...}
{loca y}            local echo on
{spdc y}            display serial port
{call setexp}       setup vars
{call dolines}      check input lines
{call drawbox}      draw box
{call drawtxt}
{call clearlines}   clear old values
{send ^[[24;1H^[[0;47;30m^[[K %usrprompt%}
{return}            return to sub that called this

{:dolines}-count data lines to display, and pad them
{setv hi,0}
{setv wid,0}
{call checklines}         count lines
{call evenout}
{return}

{:checklines}-count data lines
{incr hi}                       increment HI line number
{setv-s line,txt%hi}            put into TXT array
{leng %line}                    get length
{setv len,%_len}
{comp len,0}                    is it zero?
{ifco-e rit}                    if so, we have gone past last line
{comp len,%wid}                 compare line length with largest line length
{ifco-gc newlen}                if bigger, call NEWLEN
{goto checklines}               if not, continue counting lines

 {:newlen}-note length of longest line
 {setv wid,%len}        put in WID
 {return}               back to count more lines

 {:evenout}     even out box width so symetrical
 {setv w,%wid}
 {divi w,2}
 {comp _rem,0}
 {ifco rit}
 incr wid}
 {return}

 {:drawbox}
 {call constants}                         establish constant vars
 {send %setframe%^[[%boxrow%;%boxcol%H%boxtop%}
 {setv repeat,sendmid,%hi%}
 {call repeat}
 {send ^[[%boxrow%;%boxcol%H%boxbot%}
 {return}

  {:sendmid}
  {incr boxrow}
  {send ^[[%boxrow%;%boxcol%H%boxbak%}
  {return}


 {:drawtxt}
 {send %setxt%}
 {setv repeat,sendttx,%hi%}
 {call repeat}
 {return}

 {:sendttx}
 {setv-s txt,txt%timecount}
 {send ^[[%txtrow%;%txtcol%H%txt%}
 {incr txtrow}
 {return}

{:constants}-establish constants
{setv boxrow,24}                         screen height -> HIPOS
{setv boxcol,80}                         screen width  -> WIPOS
{decr boxrow,%hi}
{decr boxcol,%wid}
{divi boxrow,2}                          divide both by two
{divi boxcol,2}
{setv txtrow,%boxrow}
{setv txtcol,%boxcol}
{incr txtrow}
{incr txtcol}
{setv boxhi,%hi}
{setv boxwid,%wid}
{incr boxwid,1}
{incr boxhi,1}
{subs boxtop,1,%boxwid,%extop%}
{setv boxtop,%exlef%%boxtop%%exrit%}
{subs boxbot,1,%boxwid,%exbot}
{setv boxbot,%exlef%%boxbot%%exrit%}
{subs boxbak,1,%boxwid,%exmid}
{setv boxbak,%exlef%%boxbak%%exrit%}
{return}                                based on one line displayed first (during width stretch) and HSTEPS pairs of lines displayed later


{:setexp}-setup for exploding windows
{spdc y}                    display serial port output
{loca y}                    local echo on
{setg 15}                   set getstring timeout to 15 seconds
{setv tenths,0}
{setv hxcount,0}
{setv txtcount,0}
{setv hi,0}
{setv wid,0}
{setv xpos,0}
{setv ypos,0}
{setv hcount,1}
{setv wcount,1}
{setv centwi,0}
{setv centhi,0}
{setv exlef,}
{setv exrit,}
{setv extop,}
{setv exbot,}
{setv exmid,                                                                                }
{comp graphics,1}
{ifco-c b&w,color}
{return}

{:b&w}
{setv setframe,^[[0m}
{setv setxt,^[[0m}
{return}

{:color}
{setv setframe,%ansi3}
{setv setxt,%ansi4}
{return}

{:assicolor}
{setv setframe,%ansi3}
{setv setxt,%ansi4}
{return}

{:clearlines}-clear out necessary vars so explode can be run several times
{setv repeat,cler,25}
{call repeat}
{setv nowtext}
{setv thistext}
{return}

{:cler}
{setv txt%hcount}
{return}

{:explotty}     tty graphics display
{setv hi,0}
{call checklines}
{call sendtty}
{call clearlines}
{send %usrprompt%^M^J}
{return}

{:sendtty}
{setv repeat,ttout,%hi}
{call repeat}
{return}

 {:ttout}
 {setv-s ttout,txt%timecount}
 {send ^M^J%ttout%}
 {return}

- ----------------------------End Explode--------------------------------------


{:showtime}         display time and pending event information
{call timegrap}     set graph vars for time only
{call evtgraph}     modify graph for event
{call prepgraph}    prepare info for display
{call explode}      display in exploding box
{setg 15}
{gets-h ap,1}       wait for user to finish reading (user input timeout)
{return}

{:timegrap}         get graph vars for system time
{setv das,}
{setv asd,}
{setv dsd,}
{subs asd,1,%gfxnow,%asd}            black-out time blocks that have passed
{setv nex2blk,%gfxnow}               determine next-to-block position
{incr nex2blk}                         do it
{subs das,%nex2blk,100,%das}           extract # time blocks that haven't passed
{setv phasebar,%asd%%das}              combine both to form time line
{return}

{:evtgraph}   modify time bar with pending event info
{setv rpendblk,%pndblk24}                    set right-of-pending block pos
{incr rpendblk}                              set it
{subs tempbar,%rpendblk,100,%phasebar}       right-trunc phasebar @ check point
{setv tempbar,%tempbar}                     prefix with checkmark
{setv npendblk,%pndblk24}                    store pending block pos
{decr npendblk}                              take one off
{subs tempbar1,1,%npendblk,%phasebar}        left-trunc phasebar
{setv phasebar,%tempbar1%%tempbar}           append right-trunc to this
{subs ambar,1,48,%phasebar}                  divide in two for am + pm
{subs pmbar,49,100,%phasebar}                get pm bar
{return}

{:prepgraph}               prepare information for display
{setv txt1,  Time}
{setv txt2,  %ambar% AM}
{setv txt3,  1234567891011}
{setv txt4,  %pmbar% PM}
{setv txt5,           = Next System Event   (%when%)}
{setv txt6}
{return}

- ---------------------CBV Boxes -----------------------------------------


      {:mtbox}         empty box
      {comp graphics,0}
      {ifco mttty}
      {setv txt1,  Session-by-Session Callback Verifier            }
      {setv txt2, }
      {setv txt3, }
      {setv txt4, }
      {setv txt5, }
      {setv txt6}
      {call explode}
      {return}

      {:mttty}
      {setv txt1,Session-by-Session Callback Verifier}
      {setv txt2}
      {call explode}
      {return}

      {:tellbox}      tell user how to answer
      {setv txt1,              Instructions                  }
      {setv txt2,   System will now hang-up and call you back  }
      {setv txt3,                                              }
      {setv txt4,            Look for word: RING               }
      {setv txt5,            Type: ATA [Enter]                 }
      {setv txt6,                                              }
      {setv txt7,      - Callback can take about a minute -    }
      {setv txt8}
      {call explode}
      {return}

      {:passbox}
      {comp graphics,0}
      {ifco passtty}
      {setv txt1,      M4CBV Password Check                                  }
      {setv txt2, }
      {setv txt3, }
      {setv txt4, }
      {setv txt5, }
      {setv txt6}
      {call explode}
      {return}

      {:passtty}
      {setv txt1,M4CBV Password Check}
      {setv txt2}
      {call explode}
      {return}


  {:bakdrop}
  {comp graphics,1}
  {ifco-c blbak,cback}
  {setv vr,M4 v%version% Front End}
  {leng %vr}
  {setv len,%_len}
  {setv tlen,31}
  {decr tlen,%len}
  {divi tlen,2}
  {subs tr,1,%tlen,%blanks}
  {setv vr,%tr%%vr%%tr%%blanks%}
  {subs vr,1,31,%vr}
  {setv tr}
  {send ^[[12;25H%idbox%%vr%}
  {send ^[[13;25H%idbox%%sysname%}
  {send ^[[14;25H%idbox%           %linmin%          }
  {send ^[[13;56H^[[0m }
  {send ^[[14;56H^[[0m }
  {send ^[[15;26H^[[0m                               }
  {return}

  {:cback} color backdrop
  {send ^[[0m%ansi1%^[[2J}
  {return}

  {:blbak}
  {send ^[[0m^[[2J}
  {return}


-----BEGIN PGP SIGNATURE-----
Version: 2.6.2

iQEVAwUBLxweRh1uLkXXbMBBAQHNTAf/R6HhU2ScG+jHSPT32rSjbPBymnbTmJJA
iiO4mODF6vUfJ/cMXwLoRVWCG5HLKF67xjraYPzjrMJHf1JdN3OQ0XTYyoDsHP8V
ipsaZLQhtg4NhkeFD2I0HHuOkoaWcWHGzCOeigvyJiJvx7N3x4Jmk7aa/enoQJj9
Cml4uzV0Wq3otYCkHBgaP/TJS9pq9GQzEqLKrWLGyKO9JOOigb41DQkaYkZ/qm21
DwERCMxAMs5ntJbedUpU/UW5babZrekOQz186YhiXFK7h4YurGxeXFEz6eex0rOo
8PJNZdj3pbkhbLcpBXTb9roV5cF3oJw5kiuojhbHQHvm2z5lxBAGzw==
=/d5D
-----END PGP SIGNATURE-----
